/**
 * CesarApp.java
 *
 * Implementação de uma cifra de César.
 * 
 * Copyright (C) 2010 Sérgio Lopes
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.sergiolopes.formacao.cifracesar;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JFileChooser;

public class CesarApp extends javax.swing.JFrame {

    private Cesar cesar;

    public CesarApp() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jtbToolbar = new javax.swing.JToolBar();
        jbtnCifrar = new javax.swing.JButton();
        jbtnDecifrar = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jbtnAbrirFicheiro = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jLabel1 = new javax.swing.JLabel();
        spinnerDeslocamento = new javax.swing.JSpinner();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        toggleEsquerda = new javax.swing.JToggleButton();
        toggleDireita = new javax.swing.JToggleButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtOrigem = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtDestino = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jtbToolbar.setRollover(true);

        jbtnCifrar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/sergiolopes/formacao/cifracesar/link.png"))); // NOI18N
        jbtnCifrar.setFocusable(false);
        jbtnCifrar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbtnCifrar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbtnCifrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnCifrarActionPerformed(evt);
            }
        });
        jtbToolbar.add(jbtnCifrar);

        jbtnDecifrar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/sergiolopes/formacao/cifracesar/link_break.png"))); // NOI18N
        jbtnDecifrar.setFocusable(false);
        jbtnDecifrar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbtnDecifrar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbtnDecifrar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnDecifrarActionPerformed(evt);
            }
        });
        jtbToolbar.add(jbtnDecifrar);
        jtbToolbar.add(jSeparator1);

        jbtnAbrirFicheiro.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/sergiolopes/formacao/cifracesar/file_manager.png"))); // NOI18N
        jbtnAbrirFicheiro.setFocusable(false);
        jbtnAbrirFicheiro.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jbtnAbrirFicheiro.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jbtnAbrirFicheiro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jbtnAbrirFicheiroActionPerformed(evt);
            }
        });
        jtbToolbar.add(jbtnAbrirFicheiro);
        jtbToolbar.add(jSeparator2);

        jLabel1.setText("Deslocamento");
        jtbToolbar.add(jLabel1);

        spinnerDeslocamento.setModel(new javax.swing.SpinnerNumberModel(3, 3, 26, 1));
        spinnerDeslocamento.setMaximumSize(new java.awt.Dimension(50, 32767));
        jtbToolbar.add(spinnerDeslocamento);
        jtbToolbar.add(jSeparator3);

        buttonGroup1.add(toggleEsquerda);
        toggleEsquerda.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/sergiolopes/formacao/cifracesar/arrow_left.png"))); // NOI18N
        toggleEsquerda.setFocusable(false);
        toggleEsquerda.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleEsquerda.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jtbToolbar.add(toggleEsquerda);

        buttonGroup1.add(toggleDireita);
        toggleDireita.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/sergiolopes/formacao/cifracesar/arrow_right.png"))); // NOI18N
        toggleDireita.setSelected(true);
        toggleDireita.setFocusable(false);
        toggleDireita.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        toggleDireita.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jtbToolbar.add(toggleDireita);

        getContentPane().add(jtbToolbar, java.awt.BorderLayout.PAGE_START);

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        txtOrigem.setColumns(20);
        txtOrigem.setRows(5);
        jScrollPane1.setViewportView(txtOrigem);

        jSplitPane1.setTopComponent(jScrollPane1);

        txtDestino.setColumns(20);
        txtDestino.setEditable(false);
        txtDestino.setRows(5);
        jScrollPane2.setViewportView(txtDestino);

        jSplitPane1.setRightComponent(jScrollPane2);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jbtnCifrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnCifrarActionPerformed
        if (!txtOrigem.getText().trim().isEmpty()) {
            cesar = new Cesar(txtOrigem.getText().trim(),
                    Integer.parseInt(spinnerDeslocamento.getValue().toString()), toggleDireita.isSelected() ? 1 : 2);
            txtDestino.setText(cesar.cifrar());
        }
    }//GEN-LAST:event_jbtnCifrarActionPerformed

    private void jbtnDecifrarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnDecifrarActionPerformed
        if (!txtOrigem.getText().trim().isEmpty()) {
            cesar = new Cesar(txtOrigem.getText().trim(),
                    Integer.parseInt(spinnerDeslocamento.getValue().toString()), toggleDireita.isSelected() ? 1 : 2);
            txtDestino.setText(cesar.decifrar());
        }
    }//GEN-LAST:event_jbtnDecifrarActionPerformed

    private void jbtnAbrirFicheiroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jbtnAbrirFicheiroActionPerformed
        JFileChooser jfc = new JFileChooser();
        jfc.setMultiSelectionEnabled(false);

        if (jfc.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            BufferedReader bin = null;
            try {
                String linha = null;
                txtOrigem.setText("");
                txtDestino.setText("");
                bin = new BufferedReader(new FileReader(jfc.getSelectedFile()));
                while ((linha = bin.readLine()) != null) {
                    txtOrigem.append(linha);
                    txtOrigem.append("\n");
                }
            } catch (FileNotFoundException ex) {
                System.err.println(ex.getMessage());
            } catch (IOException ex) {
                System.err.println(ex.getMessage());
            } finally {
                try {
                    bin.close();
                } catch (IOException ex) {
                    System.err.println(ex.getMessage());
                }
            }

        }
    }//GEN-LAST:event_jbtnAbrirFicheiroActionPerformed

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new CesarApp().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JButton jbtnAbrirFicheiro;
    private javax.swing.JButton jbtnCifrar;
    private javax.swing.JButton jbtnDecifrar;
    private javax.swing.JToolBar jtbToolbar;
    private javax.swing.JSpinner spinnerDeslocamento;
    private javax.swing.JToggleButton toggleDireita;
    private javax.swing.JToggleButton toggleEsquerda;
    private javax.swing.JTextArea txtDestino;
    private javax.swing.JTextArea txtOrigem;
    // End of variables declaration//GEN-END:variables
}
